#define __BULDING_PERCOVIEW_H 1

#include "PercoView.h"
#include <Messenger.h>
#include "PercoLinker.h"
#include "Verbosity.h"
#include "PercolatorCodes.h"

BPercoView::BPercoView(BRect frame, const char *name, uint32 resizingMode, uint32 flags)
  :BView(frame, name, resizingMode, flags | B_FRAME_EVENTS)
{
  lnk_PercoLinker = NULL;
};

BPercoView::BPercoView(BMessage *msg_archive)
  :BView(msg_archive)
{
  lnk_PercoLinker = NULL;
};

BPercoView::~BPercoView()
{
  if (lnk_PercoLinker)
    delete lnk_PercoLinker;
};

void BPercoView::MessageReceived(BMessage *msg_received)
{
  if (lnk_PercoLinker)  //forward the message to the looper.
    lnk_PercoLinker->SendMessage(msg_received);
  BView::MessageReceived(msg_received);	//forward it up the hierarchy.
};

void BPercoView::FrameResized(float width, float height)
{
  cout << "view resized" << endl;
  if (lnk_PercoLinker)
  {														//prepare a message
    BMessage *msg_resize = new BMessage(B_PERCOLATOR_RESIZE_NOTIFY);
      msg_resize->AddFloat("Be:PERC:width", width);		//load data
      msg_resize->AddFloat("Be:PERC:height", height);
      cout << "sending message" << endl;
      lnk_PercoLinker->SendMessage(msg_resize);
    delete msg_resize;
  };
};

BArchivable *BPercoView::Instantiate(BMessage *msg_archive)
{
  return new BPercoView(msg_archive);
};

void BPercoView::AssociateConduit(BPercoLinker *lnk_Conduit)
{
  lnk_PercoLinker = new BMessenger(NULL, lnk_Conduit);
};