//PercoView.h -- this file describes the percoview percolator helper class.

#ifndef __B_PERCOVIEW_H
#define __B_PERCOVIEW_H

#if __BUILDING_PERCOVIEW_H
  #define __PERCOVIEW_TYPED __declspec(dllimport)
#else
  #define __PERCOVIEW_TYPED __declspec(dllexport)
#endif

#include <View.h>

class BMessage;
class BMessenger;
class BPercoLinker;

class __PERCOVIEW_TYPED BPercoView:public BView
{
  public:
    BPercoView(BRect frame, const char *name, uint32 resizingMode, uint32 flags);
    BPercoView(BMessage *msg_archive);
    ~BPercoView();
    
    virtual void MessageReceived(BMessage *msg_received);
    virtual void FrameResized(float width, float height);
    
    static BArchivable *Instantiate(BMessage *msg_archive);
    
    void AssociateConduit(BPercoLinker *lnk_Conduit);
    
  private:
    BMessenger *lnk_PercoLinker;
};

#endif